# Coveo FacetsMobileMode Component (CoveoFacetsMobileMode)

This component lets you customize the mobile responsive behavior of facets in your search interface.

Notes:

- You can include this component anywhere under the root element of your search interface.
- You should only include this component once in your search interface.
- If you do not include this component in your search interface, facets will still have a default mobile responsive behavior.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- breakpoint
- displayOverlayWhileOpen
- isModal
- preventScrolling
- scrollContainer

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### breakpoint

breakpoint: number

- Defined in ui/FacetsMobileMode/FacetsMobileMode.ts :36

The screen width (in number of pixels) at which facets should enter mobile responsive mode and be collapsed under a single button.

Default: `800`

Markup configuration example(s) :

    data-breakpoint='10'

### displayOverlayWhileOpen

displayOverlayWhileOpen: boolean

- Defined in ui/FacetsMobileMode/FacetsMobileMode.ts :48

Whether to display an overlay behind the facets when the end user expands them in mobile responsive mode.

By default, the following behavior applies:

- `true` when isModal is `false`
- `false` when isModal is `true`

Markup configuration example(s) :

    data-display-overlay-while-open='true'
    data-display-overlay-while-open='false'

### isModal

isModal: boolean

- Defined in ui/FacetsMobileMode/FacetsMobileMode.ts :40

Whether to display the facets in a modal instead of a pop-up when the end user expands them in mobile responsive mode.

Default

  `false`

Markup configuration example(s) :

    data-is-modal='true'
    data-is-modal='false'

### preventScrolling

preventScrolling: boolean

- Defined in ui/FacetsMobileMode/FacetsMobileMode.ts :58

Whether to disable vertical scrolling on the specified or resolved `scrollContainer` while facets are expanded in mobile responsive mode.

By default, the following behavior applies:

- `true` when isModal is `true`
- `false` when isModal is `false`

Markup configuration example(s) :

    data-prevent-scrolling='true'
    data-prevent-scrolling='false'

### scrollContainer

scrollContainer: HTMLElement

- Defined in ui/FacetsMobileMode/FacetsMobileMode.ts :70

The HTML element whose vertical scrolling should be locked while facets are expanded in mobile responsive mode.

By default, the component tries to detect and use the first ancestor element whose CSS `overflow-y` attribute is set to `scroll`, starting from the `FacetsMobileMode`'s element itself. If no such element is found, the `document.body` element is used.

Since this heuristic is not perfect, we strongly recommend that you manually set this option by explicitly specifying the desired CSS selector.

Example: `data-scroll-container-selector='#someCssSelector'`

Only effective when

  `preventScrolling` is set to `true`

## Constructors

### constructor

- new FacetsMobileMode(element: HTMLElement, type: string, bindings?: IComponentBindings): FacetsMobileMode

- Inherited from Component.constructor

  - Defined in ui/Base/Component.ts :296

  Create a new Component. Resolve all IComponentBindings if not provided.
  Create a new Logger for this component. Attach the component to the SearchInterface.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to create the component. Used to bind data on the element.

  - ##### type: string

    The unique identifier for this component. See: IComponentDefinition.ID. Used to generate the unique Coveo CSS class associated with every component.

  - ##### Default value bindings: IComponentBindings = {}

    The environment for every component. Optional, but omitting to provide one will impact performance.

  #### Returns FacetsMobileMode